#pragma once

#include "ycapture.h"
#include "IYCSource.h"
class IReceiver;

/**
* tB^`łB
*/
extern const AMOVIESETUP_FILTER sudCaptureSource;
extern const AMOVIESETUP_PIN sudCaptureSourceOut;

/**
* Lv`\[XtB^łB
*/
class CaptureSource :
	public CSource, public IQualityControl, public IYCSource
{
public:

	/**
	* CX^X𐶐܂B
	*/
    static CUnknown * WINAPI CreateInstance(LPUNKNOWN lpunk, HRESULT *phr);

private:

	/**
	* \z܂B
	*/
	CaptureSource(LPUNKNOWN lpunk, HRESULT* phr);

public:

	/**
	* j܂B
	*/
	virtual ~CaptureSource(void);

	DECLARE_IUNKNOWN;

	/**
	* C^tF[X擾܂B
	*/
    virtual STDMETHODIMP NonDelegatingQueryInterface(REFIID riid, void ** ppv);

	/**
	* iʒm܂B
	*/
	virtual STDMETHODIMP Notify(IBaseFilter *pSelf, Quality q);

	/**
	* iǗIuWFNgݒ肵܂B
	*/
	virtual STDMETHODIMP SetSink(IQualityControl *piqc);

private:

	/**
	* sȂ܂B
	*/
	HRESULT Init(IReceiver* pReceiver, int fps);

	/**
	* Lv`Xg[łB
	*/
	class CaptureStream : public CSourceStream, public IKsPropertySet, public IAMStreamConfig
	{
	public:

		/**
		* \z܂B
		*/
		CaptureStream(CaptureSource* pOwner, IReceiver* pReceiver, int fps, HRESULT* phr);

		/**
		* j܂B
		*/
		virtual ~CaptureStream();

		DECLARE_IUNKNOWN;

		/**
		* C^tF[X擾܂B
		*/
		virtual STDMETHODIMP NonDelegatingQueryInterface(REFIID riid, void ** ppv);

		/**
		* IKsPropertySetC^tF[X̎łB
		*/
		virtual STDMETHODIMP QuerySupported(REFGUID rguidPropSet, ULONG ulId, PULONG pulTypeSupport);

		/**
		* IKsPropertySetC^tF[X̎łB
		*/
		virtual STDMETHODIMP Get(REFGUID rguidPropSet, ULONG ulId, LPVOID pInstanceData, ULONG ulInstanceLength, LPVOID pPropertyData, ULONG ulDataLength, PULONG pulBytesReturned);

		/**
		* IKsPropertySetC^tF[X̎łB
		*/
		virtual STDMETHODIMP Set(REFGUID rguidPropSet, ULONG ulId, LPVOID pInstanceData, ULONG ulInstanceLength, LPVOID pPropertyData, ULONG ulDataLength);

		/**
		* obt@̓eXV܂B
		*/
		virtual HRESULT FillBuffer(IMediaSample *pSamp);

		/**
		* obt@TCY肵܂B
		*/
		virtual HRESULT DecideBufferSize(IMemAllocator * pAlloc, ALLOCATOR_PROPERTIES * pRequest);

		/**
		* iʒm܂B
		*/
		virtual STDMETHODIMP Notify(IBaseFilter *pSelf, Quality q);

		/**
		* iǗIuWFNgݒ肵܂B
		*/
		virtual STDMETHODIMP SetSink(IQualityControl *piqc);

		/**
		* tH[}bgݒ肵܂B
		*/
        virtual STDMETHODIMP SetFormat(AM_MEDIA_TYPE *pmt);
        
		/**
		* tH[}bg擾܂B
		*/
        virtual STDMETHODIMP GetFormat(AM_MEDIA_TYPE **ppmt);
        
		/**
		* ݒ̐擾܂B
		*/
        virtual STDMETHODIMP GetNumberOfCapabilities(int *piCount, int *piSize);
        
		/**
		* ݒ擾܂B
		*/
        virtual STDMETHODIMP GetStreamCaps(int iIndex, AM_MEDIA_TYPE **ppmt, BYTE *pSCC);

	protected:

		/**
		* fBA^Cv擾܂B
		*/
	    virtual HRESULT GetMediaType(CMediaType *pMediaType);

		/**
		* XbhJnʒm܂B
		*/
		virtual HRESULT OnThreadStartPlay(void);

	private:

		/**
		* XP[O֌Wp[^擾܂B
		*/
		HRESULT GetScaling(int width, int height, double* pScaling, double* pOffsetX, double* pOffsetY);

		/**
		* ێ܂B
		*/
		LONGLONG m_llTime;

		/**
		* t[ێ܂B
		*/
		LONGLONG m_llFrame;

		/**
		* t[[gێ܂B
		*/
		REFERENCE_TIME m_avgTimePerFrame;

		/**
		* ێ܂B
		*/
		int m_iPrefWidth;

		/**
		* ێ܂B
		*/
		int m_iPrefHeight;

		/**
		* ŏITv̎ێ܂B
		*/
		LONGLONG m_llLastSampleTime;

		/**
		* MIuWFNgێ܂B
		*/
		IReceiver* m_pReceiver;

	};

};
